// FieldEnergy.cpp: FieldEnergy NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MeshEditor.h"
#include "FieldEnergy.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

FieldEnergy::FieldEnergy()
{

}

FieldEnergy::~FieldEnergy()
{

}

float FieldEnergy::func(float p[])
{
	double E = 0;

	for(int i=0; i<n; i++){
		int deg = degree[i];
		if(deg == 0){
			continue;
		}
		double* phii = phi[i];
		int* l = link[i];
		for(int j=0; j<deg; j++){
			int pair = l[j];
			int search = -1;
			for(int k=0; k<degree[pair]; k++)
				if(link[pair][k] == i){
					search = k;
					break;
				}
			if(search < 0)
				continue;
			E -= 0.5*cos(2.0*((p[i]-phii[j]) 
					- (p[pair]-phi[pair][search])));
		}	
	}
	return (float)E;
}

void FieldEnergy::initData(int n, double **phi, int **link, int *degree)
{
	this->phi = phi;
	this->n = n;
	this->link = link;
	this->degree = degree;
}

void FieldEnergy::dfunc(float p[], float d[])
{
	for(int i=0; i<n; i++){
		int deg = degree[i];
		double di = 0;
		if(deg == 0){
			continue;
		}
		double* phii = phi[i];
		int* l = link[i];
		for(int j=0; j<deg; j++){
			int pair = l[j];
			int search = -1;
			for(int k=0; k<degree[pair]; k++)
				if(link[pair][k] == i){
					search = k;
					break;
				}
			if(search < 0)
				continue;
			di += (2.0*sin(2.0*((p[i]-phii[j]) 
						- (p[pair]-phi[pair][search]))));
		}
		d[i] = (float)di;
	}
}
